#include <WindowsConstants.au3>
#include "WortDiff.au3"
#include <Misc.au3>
Global $_Intelli_Array, $_Intelli_GUI, $_Intelli_Edit[6], $_Intelli_Labels[1], _
$_Intelli_Word, $_Intelli_Pos[2], $_Intelli_UpdateCount, $_Intelli_ArrayPos, $_Intelli_ArrayUBound, _
$_Intelli_Aktuell[1][2], $_Intelli_GUILines, $_Intelli_Update, $_Intelli_Change[5], _
$_Intelli_MainGUI, $_Intelli_UpdateTimer, $_Intelli_FadeOutTimer, $_Intelli_Hide, $_Intelli_Pos1D

Func _Intelli_SetText()
	If _IsPressed('0D') Then ; Enter wurde gedrckt: Ergebnis 1 wird genommen
		Local $s = $_Intelli_Edit[5]
		$s = StringLeft($s, $_Intelli_Pos1D - StringLen($_Intelli_Word)) & $_Intelli_Aktuell[0][1]
		GUICtrlSetData($_Intelli_Edit[4], $s)
	EndIf
EndFunc

Func _Intelli_Update()
	If Not $_Intelli_Hide Then
		If TimerDiff($_Intelli_FadeOutTimer) > 5000 Or _IsPressed('0D') Then
			WinSetTrans($_Intelli_GUI, '', 0)
			$_Intelli_Hide = True
			_Intelli_SetText()
		EndIf
	EndIf
	If $_Intelli_Change Then
		$_Intelli_Word = $_Intelli_Change
		$_Intelli_ArrayPos = 0
		$_Intelli_Update = True
		$_Intelli_Change = ''
		__Intelli_MoveGUI()
	EndIf
	If Not $_Intelli_Word Then Return
	If Not ($_Intelli_ArrayPos = $_Intelli_ArrayUBound) Then
		Local $iTMP
		$_Intelli_Update = False
		$iTMP = $_Intelli_ArrayPos + $_Intelli_UpdateCount
		If $iTMP > $_Intelli_ArrayUBound Then $iTMP = $_Intelli_ArrayUBound
		Local $aTMP[$iTMP-$_Intelli_ArrayPos+$_Intelli_GUILines][2]
		For $i = 0 To $iTMP - $_Intelli_ArrayPos - 1 Step 1
			$aTMP[$i][0] = _Dist_Calc($_Intelli_Array[$i+$_Intelli_ArrayPos], $_Intelli_Word)
			$aTMP[$i][1] = $_Intelli_Array[$i+$_Intelli_ArrayPos]
		Next
		For $i = 0 To $_Intelli_GUILines - 1 Step 1
			$aTMP[$i+$iTMP - $_Intelli_ArrayPos][0] = _Dist_Calc($_Intelli_Aktuell[$i][1], $_Intelli_Word)
			$aTMP[$i+$iTMP - $_Intelli_ArrayPos][1] = $_Intelli_Aktuell[$i][1]
		Next
		_Intelli_KillDoublesSort($aTMP)
		For $i = 0 To $_Intelli_GUILines - 1 Step 1
			$_Intelli_Aktuell[$i][0] = $aTMP[$i][0]
			$_Intelli_Aktuell[$i][1] = $aTMP[$i][1]
		Next
		$_Intelli_ArrayPos = $iTMP - 1
		If $_Intelli_ArrayPos + 2 > $_Intelli_ArrayUBound Then $_Intelli_ArrayPos = $_Intelli_ArrayUBound
		$_Intelli_Update = True
	EndIf
	If $_Intelli_Update And TimerDiff($_Intelli_UpdateTimer) > 200 Then
		$_Intelli_UpdateTimer = TimerInit()
		$_Intelli_Update = False
		For $i = 0 To $_Intelli_GUILines - 1 Step 1
			GUICtrlSetData($_Intelli_Labels[$i], $_Intelli_Aktuell[$i][1])
		Next
	EndIf
EndFunc

Func __Intelli_MoveGUI()
	$_Intelli_Hide = False
	$_Intelli_FadeOutTimer = TimerInit()
	Local $aPos = WinGetPos($_Intelli_MainGUI)
	WinMove($_Intelli_GUI, '', Int($aPos[0] + $_Intelli_Edit[0] + $_Intelli_Pos[0] * 8) - 32, 28 + Int($aPos[1] + $_Intelli_Edit[1] + $_Intelli_Pos[1] * 16))
	WinSetTrans($_Intelli_GUI, '', 255)
EndFunc

Func _Intelli_CreateEdit($sText, $iX, $iY, $iW, $iH, $iStyle = -1, $iExStyle = 0)
	Local $hEdit = GUICtrlCreateEdit($sText, $iX, $iY, $iW, $iH, $iStyle, $iExStyle)
	GUICtrlSetFont($hEdit, 10, 400, 0, 'Courier New')
	$_Intelli_Edit[0] = $iX
	$_Intelli_Edit[1] = $iY
	$_Intelli_Edit[2] = $iW
	$_Intelli_Edit[3] = $iH
	$_Intelli_Edit[4] = $hEdit
	$_Intelli_Edit[5] = '' ; Alter inhalt
	Return $hEdit
EndFunc

Func _Intelli_Startup($sPfad_Dateiliste, $hGUI, $iW = 256, $iBoxLines = 8, $iMax = 9000, $iMinLen = 5, $iUpdateCount = 25)
	$_Intelli_MainGUI = $hGUI
	$_Intelli_Array = _Intelli_FileToArray($sPfad_Dateiliste, $iMax, $iMinLen)
	$_Intelli_ArrayUBound = UBound($_Intelli_Array)
	If $iBoxLines > $_Intelli_ArrayUBound Then $iBoxLines = $_Intelli_ArrayUBound
	ReDim $_Intelli_Labels[$iBoxLines] ; Anzahl Listenpltze
	ReDim $_Intelli_Aktuell[$iBoxLines][2]
	$_Intelli_GUI = GUICreate('', $iW, $iBoxLines * 16, 0, 0, $WS_POPUP)
	WinSetOnTop($_Intelli_GUI, '', 1)
	WinSetTrans($_Intelli_GUI, '', 0)
	GUISetState(@SW_SHOW, $_Intelli_GUI)
	For $i = 0 To $iBoxLines - 1 Step 1
		$_Intelli_Labels[$i] = GUICtrlCreateLabel('Test', 0, $i * 16, $iW, 16, 1)
		$_Intelli_Aktuell[$i][0] = 999
	Next
	$_Intelli_UpdateCount = $iUpdateCount
	$_Intelli_GUILines = $iBoxLines
	$_Intelli_UpdateTimer = TimerInit()
	$_Intelli_Hide = True
	GUIRegisterMsg($WM_COMMAND, '_Intelli_WM_COMMAND')
EndFunc

Func _Intelli_GetList($s1, $a, $iAnz = 8)
	Local $iUbound = UBound($a), $x[$iUbound - 1][2], $iLen = StringLen($s1)
	If $iLen < 4 Then Return
	For $i = 1 To $iUbound - 1 Step 1
		$x[$i-1][0] = (_Dist_Calc($s1, StringLeft($a[$i], $iLen)) + _Dist_Calc($s1, $a[$i]))/2
		$x[$i-1][1] = $a[$i]
	Next
	_Intelli_ArraySort2D($x)
	Local $aRet[$iAnz]
	For $i = 0 To $iAnz - 1 Step 1
		$aRet[$i] = $x[$i][1]
	Next
	Return $aRet
EndFunc

Func _Intelli_FileToArray($sPfad, $iMax = 500, $iMinLen = 5)
	Local $aRet = StringSplit(StringReplace(FileRead($sPfad), @CR, ''), @LF, 2)
	If $iMax > UBound($aRet) Then $iMax = UBound($aRet)
	ReDim $aRet[$iMax]
	Local $aKlon[$iMax]
	For $i = 0 To $iMax - 1 Step 1
		If StringLen($aRet[$i]) < $iMinLen Then $aKlon[$i] = True
	Next
	For $i = $iMax - 1 To 0 Step -1
		If $aKlon[$i] Then _Intelli_ArrayDelete1D($aRet, $i)
	Next
	Return $aRet
EndFunc

Func _Intelli_ArrayDelete1D(ByRef $a, $e)
	Local $u = UBound($a, 1) - 1
	For $i = $e To $u - 1 Step 1
		$a[$i] = $a[$i + 1]
	Next
	ReDim $a[$u]
EndFunc

Func _Intelli_ArraySort2D(ByRef $a, $iSubItem = 0)
	Local $iSubMax = UBound($a, 2) - 1, $iStep = 1, $iStart = 0, $iEnd = UBound($a) - 1
	__Intelli_ArraySort2D($a, $iStep, $iStart, $iEnd, $iSubItem, $iSubMax)
EndFunc

Func __Intelli_ArraySort2D(ByRef $avArray, ByRef $iStep, ByRef $iStart, ByRef $iEnd, ByRef $iSubItem, ByRef $iSubMax)
	If $iEnd <= $iStart Then Return
	Local $vTmp, $L = $iStart, $R = $iEnd, $vPivot = $avArray[Int(($iStart + $iEnd) / 2)][$iSubItem], $fNum = IsNumber($vPivot)
	Do
		If $fNum Then
			While ($iStep * ($avArray[$L][$iSubItem] - $vPivot) < 0 And IsNumber($avArray[$L][$iSubItem])) Or (Not IsNumber($avArray[$L][$iSubItem]) And $iStep * StringCompare($avArray[$L][$iSubItem], $vPivot) < 0)
				$L += 1
			WEnd
			While ($iStep * ($avArray[$R][$iSubItem] - $vPivot) > 0 And IsNumber($avArray[$R][$iSubItem])) Or (Not IsNumber($avArray[$R][$iSubItem]) And $iStep * StringCompare($avArray[$R][$iSubItem], $vPivot) > 0)
				$R -= 1
			WEnd
		Else
			While ($iStep * StringCompare($avArray[$L][$iSubItem], $vPivot) < 0)
				$L += 1
			WEnd
			While ($iStep * StringCompare($avArray[$R][$iSubItem], $vPivot) > 0)
				$R -= 1
			WEnd
		EndIf
		If $L <= $R Then
			For $i = 0 To $iSubMax
				$vTmp = $avArray[$L][$i]
				$avArray[$L][$i] = $avArray[$R][$i]
				$avArray[$R][$i] = $vTmp
			Next
			$L += 1
			$R -= 1
		EndIf
	Until $L > $R
	__Intelli_ArraySort2D($avArray, $iStep, $iStart, $R, $iSubItem, $iSubMax)
	__Intelli_ArraySort2D($avArray, $iStep, $L, $iEnd, $iSubItem, $iSubMax)
EndFunc

Func _Intelli_ArrayDelete2D(ByRef $a, $e)
	Local $u = UBound($a, 1) - 1, $s = UBound($a, 2) - 1
	For $i = $e To $u - 1 Step 1
		For $j = 0 To $s Step 1
			$a[$i][$j] = $a[$i + 1][$j]
		Next
	Next
	ReDim $a[$u][$s + 1]
EndFunc

Func _Intelli_KillDoublesSort(ByRef $a)
	_Intelli_ArraySort2D($a, 1)
	Local $u = UBound($a), $aKlon[$u]
	For $i = 0 To $u - 2 Step 1
		If $a[$i][1] == $a[$i+1][1] Then $aKlon[$i] = 1
	Next
	For $i = $u - 1 To 0 Step -1
		If $aKlon[$i] Then
			_Intelli_ArrayDelete2D($a, $i)
		EndIf
	Next
	_Intelli_ArraySort2D($a, 0)
EndFunc

Func _Intelli_WM_COMMAND($hWnd, $Msg, $wParam, $lParam)
	Local $Nr = BitShift($wParam, 16)
	If $Nr <> 1024 Then Return 0
	Local $sNew = GUICtrlRead($_Intelli_Edit[4])
	If Not StringStripWS(StringRight($sNew, 1),8) Then ; Letztes Zeichen ist leer
		$_Intelli_Change = ''
		$_Intelli_Update = False
;~ 		$_Intelli_Hide = True
		$_Intelli_Edit[5] = $sNew
		WinSetTrans($_Intelli_GUI, '', 0)
		Return
	EndIf
	If $_Intelli_Edit[5] = $sNew Then Return 0
	$_Intelli_Pos1D = __Intelli_FindChange($sNew, $_Intelli_Edit[5])
	$_Intelli_Edit[5] = $sNew
	$sNew = StringLeft($sNew, $_Intelli_Pos1D)
	Local $sWord = __Intelli_LastWord($sNew)
	If Not StringStripWS($sWord, 8) Then Return 0
	$_Intelli_Change = $sWord
	If $_Intelli_Change Then $_Intelli_Pos = __Intelli_FindChange2D($sNew, $sWord)
;~ 	ToolTip('X: ' & $_Intelli_Pos[0] & @CRLF & 'Y: ' & $_Intelli_Pos[1])
	Return 0
EndFunc

Func __Intelli_FindChange2D($sText, $sWord)
	Local $a = StringSplit($sText, @CR), $aRet[2] = [StringLen($a[$a[0]]), UBound($a) - 1]
	If Not ($aRet[1] = 1) Then $aRet[0] -= 1
	Return $aRet
EndFunc

Func __Intelli_LastWord($s)
	$s = StringReplace($s, @CR, ' ')
	$s = StringReplace($s, @LF, ' ')
	$s = StringReplace($s, @TAB, ' ')
	While StringInStr($s, '  ')
		$s = StringReplace($s, '  ', ' ')
	WEnd
	Local $a = StringSplit($s, ' ')
	Return $a[$a[0]]
EndFunc

Func __Intelli_FindChange($s1, $s2) ; Gibt die Position der letzten nderung zurck
	Local $l1 = StringLen($s1), $l2 = StringLen($s2), $iMaxLen = Ceiling(($l1 + $l2)/2)
	For $i = 1 To $iMaxLen Step 1
		If StringMid($s1, $i, 1) <> StringMid($s2, $i, 1) Then Return $i
	Next
EndFunc
